#include <String.h>
#include "NodePtr.DLList.h"

#include "String.NodePtrDLListPtr.AVLMap.h"

#ifndef __GRAPH_H
#define	__GRAPH_H

class Graph
{
	public :

		static NodePtrDLList	leafNodeList ;
		static NodePtrDLList	intermediateNodeList ; 	 	 

		static void ConstructGraph() ;

		static StringNodePtrDLListPtrAVLMap queryCaching ; 

		static NodePtrDLList*
		Search( Attribute& anAttribute ) ;  

		static NodePtrDLList*
		Search( String& attrName, String& attrValue )
		{
			return Graph::Search(Attribute(attrName, attrValue)) ;
		}

		static NodePtrDLList*
		Search( NodePtrDLList& aNodeList,Attribute& anAttribute) ;  

		static NodePtrDLList*
		Search( NodePtrDLList& aNodeList,String& attrName,String& attrValue ) 
		{
			return Graph::Search(aNodeList,Attribute(attrName,attrValue)) ;
		}

		static int
		NumberOfNodes()
		{
			return Graph::leafNodeList.length() ;
		}

		static NodePtr
		SearchForNode( String& nodeName ) ; 
} ;

#endif 
