LFLAGS=
YFLAGS=-dv
CFLAGS=-c -g -Wall
CC=gcc
YACC=yacc
LEX=flex
OBJS=y.tab.o lex.yy.o error.o
RESULT=test


$(RESULT): $(OBJS)
	$(CC) -o $(RESULT) $(OBJS) -ly

y.tab.o: y.tab.c
	$(CC) $(CFLAGS) y.tab.c

lex.yy.o: lex.yy.c y.tab.h
	$(CC) $(CFLAGS) lex.yy.c

y.tab.c: parser.y
	$(YACC) $(YFLAGS) parser.y

lex.yy.c: c.lex
	$(LEX) $(LFLAGS) c.lex

error.o: error.c error.h
	$(CC) $(CFLAGS) error.c

clean:
	rm y.tab.c lex.yy.c y.tab.h y.output *.o
