#include <iostream.h>
#include "Edge.h"
#include "Node.h"

bool
Edge::operator = (const Edge& anEdge)
{
 	return !compare(nodePtr->name,anEdge.nodePtr->name) ? 1 : 0 ;
}

int
Edge::operator <= (const Edge& anEdge)
{
        return compare(nodePtr->name,anEdge.nodePtr->name) ;
}

ostream&
operator << (ostream& os, Edge& anEdge)
{
        if ( !anEdge.nodePtr || anEdge.nodePtr->name.empty() )
	{
		os << "(null) " ;
	}
	else
	{
		os << anEdge.nodePtr->name << " " ; 
	}

	return os ; 
}

