#ifndef __EDGEPTR_DEFS_H
#define __EDGEPTR_DEFS_H

#include <iostream.h>
#include <String.h>

class Node ;

class Edge
{
	public :

		String		nodeName ;
		Node*		nodePtr ; 

		Edge() : nodePtr(0) { } ; 

		bool
		operator = (const Edge& anEdge) ; 

		int
		operator <= (const Edge& anEdge) ; 

		friend ostream&
		operator << (ostream& os, Edge& aEdge) ; 
} ;

#endif
